'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _chart = require('../chart');

var _chart2 = _interopRequireDefault(_chart);

var _invalidGrammarError = require('../../errors/invalid-grammar-error');

var _invalidGrammarError2 = _interopRequireDefault(_invalidGrammarError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Represents a Stacked Area Chart.
 */
var StackedAreaChart = function (_Chart) {
	_inherits(StackedAreaChart, _Chart);

	/**
  * Creates an instance of the StackedAreaChart class
  * @param {string} data - JSON string containing the data columns.
  */
	function StackedAreaChart(data) {
		_classCallCheck(this, StackedAreaChart);

		return _possibleConstructorReturn(this, (StackedAreaChart.__proto__ || Object.getPrototypeOf(StackedAreaChart)).call(this, data));
	}

	/**
  * Alter the parameters of the chart using the provided grammar.
  * @param {string} grammar - Simple grammar string describing the chart.
  * @returns {boolean} - Returns true if the grammar is parsed.
  */


	_createClass(StackedAreaChart, [{
		key: 'do',
		value: function _do(grammar) {
			if (!_get(StackedAreaChart.prototype.__proto__ || Object.getPrototypeOf(StackedAreaChart.prototype), 'do', this).call(this, grammar)) {
				if (grammar.match(new RegExp('where [0-9a-zA-Z\\-]+ as area-spline'))) {
					var areaSplineDataLabel = grammar.match(new RegExp('where [0-9a-zA-Z\\-]+ as area-spline'))[0].split(' ')[1];
					this._outputJson.data.types[areaSplineDataLabel] = 'area-spline';
					return true;
				} else if (grammar.match(new RegExp('where [0-9a-zA-Z\\-]+ as area'))) {
					var areaDataLabel = grammar.match(new RegExp('where [0-9a-zA-Z\\-]+ as area'))[0].split(' ')[1];
					this._outputJson.data.types[areaDataLabel] = 'area';
					return true;
				} else if (grammar.match(new RegExp('group [0-9a-zA-Z\\-]+[\\s]*(,[\\s]*)+[0-9a-zA-Z\\-]+'))) {
					var labelList = grammar.match(new RegExp(' [0-9a-zA-Z\\-]+[\\s]*(,[\\s]*)+[0-9a-zA-Z\\-]+'))[0].split(',');
					labelList = labelList.map(function (e) {
						return e.trim();
					});
					this._outputJson.data.groups.push(labelList);
					return true;
				} else {
					throw new _invalidGrammarError2.default();
				}
			}
		}
	}]);

	return StackedAreaChart;
}(_chart2.default);

exports.default = StackedAreaChart;